<?php	
	if (!class_exists('TS_TablesWP_Styler')){
		class TS_TablesWP_Styler {
			function __construct() {
				// AJAX Callbacks for Database Storage
				add_action('wp_ajax_ts_tablestyler_database_restore',       array($this, 	'TS_TablesWP_Database_Restore'));
				add_action('wp_ajax_ts_tablestyler_database_save',          array($this, 	'TS_TablesWP_Database_Save'));
				add_action('wp_ajax_ts_tablestyler_database_replace',		array($this, 	'TS_TablesWP_Database_Save'));
				add_action('wp_ajax_ts_tablestyler_database_delete',		array($this, 	'TS_TablesWP_Database_Delete'));
				
				// AJAX Callbacks for Quick Storage
				add_action('wp_ajax_ts_tablestyler_session_delete',        	array($this, 	'TS_TablesWP_Quick_Delete'));
				add_action('wp_ajax_ts_tablestyler_session_restore',        array($this, 	'TS_TablesWP_Quick_Restore'));
				add_action('wp_ajax_ts_tablestyler_session_save',           array($this, 	'TS_TablesWP_Quick_Save'));
				
				// AJAX Callbacks for CSS File Export
				add_action('wp_ajax_ts_tablestyler_export_save',            array($this, 	'TS_TablesWP_Quick_Save'));
				add_action('wp_ajax_ts_tablestyler_export_file',            array($this, 	'TS_TablesWP_Quick_File'));
			}
			
			function TS_TablesWP_Database_Listing() {
				// Declare Global Variables
				global $TS_ADVANCED_TABLESWP;
				global $wpdb;
				$TS_TablesWP_Styler_BaseName				= $wpdb->prefix . TABLESWP_MYSTYLES;
				$TS_TablesWP_Styler_Results					= $wpdb->get_results("SELECT `id`, `number`, `name` FROM $TS_TablesWP_Styler_BaseName ORDER BY id", ARRAY_A);
				if ($TS_TablesWP_Styler_Results === null) {
					$TS_TablesWP_Styler_Results				= array();
				}
				return $TS_TablesWP_Styler_Results;
			}
			
			function TS_TablesWP_Database_Restore() {
				// Declare Global Variables
				global $TS_ADVANCED_TABLESWP;
				global $wpdb;		
				// Declare Error Handlers
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
					'styleid'                             	=> '',
					'stylenumber'							=> '',
					'stylename'                             => '',
					'codecss'                             	=> '',
					'codejson'                            	=> '',
				);
				// Check for NONCE Compliance
				$TS_TablesWP_Styler_ID						= "";
				$TS_TablesWP_Styler_Number					= "";
				$TS_TablesWP_Styler_Name					= "";
				$TS_TablesWP_Styler_CodeCSS					= "";
				$TS_TablesWP_Styler_CodeJSON				= "";
				if (empty($_POST) || !wp_verify_nonce($_POST['stylenonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
				} elseif (isset($_POST['action']) && $_POST['action'] == 'ts_tablestyler_database_restore') {
					$TS_TablesWP_Styler_ID					= (isset($_POST['styleid']) ? $_POST['styleid'] : '');
					$TS_TablesWP_Styler_Number				= (isset($_POST['stylenumber']) ? $_POST['stylenumber'] : '');
					$TS_TablesWP_Styler_BaseName			= $wpdb->prefix . TABLESWP_MYSTYLES;
					$TS_TablesWP_Styler_BaseData			= $wpdb->get_row("SELECT * FROM $TS_TablesWP_Styler_BaseName WHERE `id` = $TS_TablesWP_Styler_ID");
					if ($TS_TablesWP_Styler_BaseData == null) {
						$TS_TablesWP_Styler_BaseData		= array();
					}
					if (isset($TS_TablesWP_Styler_BaseData->name)) {
						$TS_TablesWP_Styler_Name			= $TS_TablesWP_Styler_BaseData->name;
					}
					if (isset($TS_TablesWP_Styler_BaseData->codecss)) {
						$TS_TablesWP_Styler_CodeCSS			= $TS_TablesWP_Styler_BaseData->codecss;
					}
					if (isset($TS_TablesWP_Styler_BaseData->codejson)) {
						$TS_TablesWP_Styler_CodeJSON		= $TS_TablesWP_Styler_BaseData->codejson;
					}
				} else {
					$error_pass 							= false;
				}
				// AJAX Return Message
				$form_response['stylename']					= $TS_TablesWP_Styler_Name;
				$form_response['stylenumber']				= $TS_TablesWP_Styler_ID;
				$form_response['codecss']					= $TS_TablesWP_Styler_CodeCSS;
				$form_response['codejson']					= $TS_TablesWP_Styler_CodeJSON;
				$form_response['success']					= $error_pass;
				$form_response['message']					= $error_code;
				wp_send_json($form_response);
				Exit();
			}
			
			function TS_TablesWP_Database_Save() {
				// Declare Global Variables
				global $TS_ADVANCED_TABLESWP;
				global $wpdb;				
				// Declare Error Handlers
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
					'stylename'                             => '',
					'stylenumber'							=> '',
					'styleresults'							=> '',
					'stylenextid'							=> '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-tablestyler-output-nonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
				} else {
					$TS_TablesWP_Styler_BaseName			= $wpdb->prefix . TABLESWP_MYSTYLES;
					$TS_TablesWP_Styler_CodeCSS             = (isset($_POST['ts-tablestyler-output-csscode']) ? $_POST['ts-tablestyler-output-csscode'] : '');
					$TS_TablesWP_Styler_CodeJSON            = (isset($_POST['ts-tablestyler-output-jsoncode']) ? $_POST['ts-tablestyler-output-jsoncode'] : '');
					$TS_TablesWP_Styler_Modified            = current_time('timestamp', false);
					$TS_TablesWP_Styler_ID					= (isset($_POST['styleid']) ? $_POST['styleid'] : '');
					$TS_TablesWP_Styler_Number				= (isset($_POST['stylenumber']) ? $_POST['stylenumber'] : '');
					$TS_TablesWP_Styler_Name				= (isset($_POST['stylename']) ? $_POST['stylename'] : '');
					if (($TS_TablesWP_Styler_CodeCSS == null) || ($TS_TablesWP_Styler_CodeCSS == "")) {               
						$error_pass 						= false;
					}
					if (isset($_POST['action'])) {
						if ($_POST['action'] == 'ts_tablestyler_database_save') {
							// Add New Style to Database
							$wpdb->insert($TS_TablesWP_Styler_BaseName, array(
								"number" 					=> $TS_TablesWP_Styler_Number,
								"name" 						=> $TS_TablesWP_Styler_Name,
								"created"					=> date("Y-m-d H:i:s", $TS_TablesWP_Styler_Modified),
								"updated"					=> date("Y-m-d H:i:s", $TS_TablesWP_Styler_Modified),
								"codecss"					=> $TS_TablesWP_Styler_CodeCSS,
								"codejson"					=> $TS_TablesWP_Styler_CodeJSON,
							));
						} elseif ($_POST['action'] == 'ts_tablestyler_database_replace') {
							// Update Style In Database
							$wpdb->update($TS_TablesWP_Styler_BaseName,
								array(
									'number' 				=> $TS_TablesWP_Styler_Number,
									"name" 					=> $TS_TablesWP_Styler_Name,
									"codecss"				=> $TS_TablesWP_Styler_CodeCSS,
									"codejson"				=> $TS_TablesWP_Styler_CodeJSON,		
								), array(
									'id' 					=> $TS_TablesWP_Styler_ID
								), null, array('%d')
							);
						}
						$TS_TablesWP_Styler_Results			= $this->TS_TablesWP_Database_Listing();
						if (($TS_TablesWP_Styler_Results === null) || (is_array($TS_TablesWP_Styler_Results) && count($TS_TablesWP_Styler_Results) === 0)) {
							$TS_TablesWP_Styler_Results		= array();
							$TS_TablesWP_Styler_NextID		= "1";
						} else {
							$TS_TablesWP_Styler_Sessions	= array();
							$TS_TablesWP_Styler_Missing		= array();
							$TS_TablesWP_Styler_Name		= "";
							if (count($TS_TablesWP_Styler_Results) == 0) {
								$TS_TablesWP_Styler_NextID	= 1;
							} else {
								foreach ($TS_TablesWP_Styler_Results as $StylerSession => $styler) {
									array_push($TS_TablesWP_Styler_Sessions, $styler['number']);
								}
								for ($i = 1; $i < max($TS_TablesWP_Styler_Sessions); $i++) {
									if (!in_array($i, $TS_TablesWP_Styler_Sessions)) {
										array_push($TS_TablesWP_Styler_Missing, $i);
									}
								}
								if ($TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_ReuseIDs == true) {
									if (count($TS_TablesWP_Styler_Missing) > 0) {
										$TS_TablesWP_Styler_NextID	= min($TS_TablesWP_Styler_Missing);
									} else {
										$TS_TablesWP_Styler_NextID	= max($TS_TablesWP_Styler_Sessions) + 1;
									}
								} else {
									$TS_TablesWP_Styler_NextID		= max($TS_TablesWP_Styler_Sessions) + 1;
								}
							}
						}
						$TS_TablesWP_Styler_Results			= json_encode($TS_TablesWP_Styler_Results);
					}
				}
				// AJAX Return Message
				$form_response['stylename']					= (isset($_POST['stylename']) ? $_POST['stylename'] : '');
				$form_response['stylenumber']				= (isset($_POST['stylenumber']) ? $_POST['stylenumber'] : '');
				$form_response['styleresults']				= $TS_TablesWP_Styler_Results;
				$form_response['stylenextid']				= $TS_TablesWP_Styler_NextID;
				$form_response['success']					= $error_pass;
				$form_response['message']					= $error_code;
				wp_send_json($form_response);
				Exit();
			}
			
			function TS_TablesWP_Database_Delete() {
				// Declare Global Variables
				global $TS_ADVANCED_TABLESWP;
				global $wpdb;				
				// Declare Error Handlers
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
					'stylename'                             => '',
					'stylenumber'							=> '',
				);
				// Check for NONCE Compliance
				$TS_TablesWP_Styler_ID						= "";
				$TS_TablesWP_Styler_Number					= "";
				$TS_TablesWP_Styler_Name					= "";
				if (empty($_POST) || !wp_verify_nonce($_POST['stylenonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
				} elseif (isset($_POST['action']) && $_POST['action'] == 'ts_tablestyler_database_delete') {
					$TS_TablesWP_Styler_ID					= (isset($_POST['styleid']) ? $_POST['styleid'] : '');
					$TS_TablesWP_Styler_Number				= (isset($_POST['stylenumber']) ? $_POST['stylenumber'] : '');
					$TS_TablesWP_Styler_Name				= (isset($_POST['stylename']) ? $_POST['stylename'] : '');
					$TS_TablesWP_Styler_BaseName			= $wpdb->prefix . TABLESWP_MYSTYLES;
					// Remove Table from Database
					$wpdb->delete($TS_TablesWP_Styler_BaseName,
						array(
							'id'							=> $TS_TablesWP_Styler_ID
						), array('%d')
					);
					$TS_TablesWP_Styler_Optimize			= $wpdb->query("OPTIMIZE TABLE $TS_TablesWP_Styler_BaseName");
				} else {
					$error_pass 							= false;
				}
				// AJAX Return Message
				$form_response['stylename']					= $TS_TablesWP_Styler_Name;
				$form_response['stylenumber']				= $TS_TablesWP_Styler_ID;
				$form_response['success']					= $error_pass;
				$form_response['message']					= $error_code;
				wp_send_json($form_response);
				Exit();
			}
			
			function TS_TablesWP_Quick_Restore() {
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
					'codecss'                               => '',
					'codejson'                              => '',
					'timestamp'                             => '',
					'timestring'                            => '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['sessionnonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
					$form_response['message']				= $error_code;
				} else {                
					$TS_TablesWP_Styler_CodeCSS             = get_option('ts_tablesplus_extend_settings_stylecss',      '');
					$TS_TablesWP_Styler_CodeJSON            = get_option('ts_tablesplus_extend_settings_stylejson',     '');
					$TS_TablesWP_Styler_Modified            = get_option('ts_tablesplus_extend_settings_styletime',     '');
					if (($TS_TablesWP_Styler_CodeCSS == null) || ($TS_TablesWP_Styler_CodeCSS == "")) {               
						$error_pass 						= false;
						$form_response['message']			= __("Unfortunately, no stored table styler session could be found or retrieved!", "ts_visual_composer_extend");
					} elseif (isset($_POST['action']) && $_POST['action'] == 'ts_tablestyler_session_restore') {
						$form_response['codecss']           = $TS_TablesWP_Styler_CodeCSS;
						$form_response['codejson']          = $TS_TablesWP_Styler_CodeJSON;
					}
				}
				// AJAX Return Message
				$form_response['success']					= $error_pass;
				if ($error_pass) {
					$form_response['timestamp']				= $TS_TablesWP_Styler_Modified;
					$form_response['timestring']			= date_i18n(get_option('date_format') . " " . get_option('time_format'), $TS_TablesWP_Styler_Modified);
				}
				wp_send_json($form_response);
				Exit();
			}
			
			function TS_TablesWP_Quick_Save() {
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
					'codecss'                               => '',
					'codejson'                              => '',
					'timestamp'                             => '',
					'timestring'                            => '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['ts-tablestyler-output-nonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
				} else {                
					$TS_TablesWP_Styler_CodeCSS             = (isset($_POST['ts-tablestyler-output-csscode']) ? $_POST['ts-tablestyler-output-csscode'] : '');
					$TS_TablesWP_Styler_CodeJSON            = (isset($_POST['ts-tablestyler-output-jsoncode']) ? $_POST['ts-tablestyler-output-jsoncode'] : '');
					$TS_TablesWP_Styler_Modified            = current_time('timestamp', false);
					if (($TS_TablesWP_Styler_CodeCSS == null) || ($TS_TablesWP_Styler_CodeCSS == "")) {               
						$error_pass 						= false;
					}
					if (isset($_POST['action']) && $_POST['action'] == 'ts_tablestyler_export_save') {
						if ($error_pass) {
							update_option('ts_tablesplus_extend_settings_exporttime',		$TS_TablesWP_Styler_Modified);
							update_option('ts_tablesplus_extend_settings_exportcss',		$TS_TablesWP_Styler_CodeCSS);
							update_option('ts_tablesplus_extend_settings_exportjson',		$TS_TablesWP_Styler_CodeJSON);
						} else {
							update_option('ts_tablesplus_extend_settings_exporttime',     	'');
							update_option('ts_tablesplus_extend_settings_exportcss',      	'');
							update_option('ts_tablesplus_extend_settings_exportjson',     	'');
						}
					} elseif (isset($_POST['action']) && $_POST['action'] == 'ts_tablestyler_session_save') {
						if ($error_pass) {
							update_option('ts_tablesplus_extend_settings_styletime',    	$TS_TablesWP_Styler_Modified);
							update_option('ts_tablesplus_extend_settings_stylecss',     	$TS_TablesWP_Styler_CodeCSS);
							update_option('ts_tablesplus_extend_settings_stylejson',    	$TS_TablesWP_Styler_CodeJSON);
						} else {
							update_option('ts_tablesplus_extend_settings_styletime',    	'');
							update_option('ts_tablesplus_extend_settings_stylecss',     	'');
							update_option('ts_tablesplus_extend_settings_stylejson',    	'');
						}
					}
				}
				// AJAX Return Message
				$form_response['success']					= $error_pass;
				$form_response['message']					= $error_code;
				if ($error_pass) {
					$form_response['timestamp']				= $TS_TablesWP_Styler_Modified;
					$form_response['timestring']			= date_i18n(get_option('date_format') . " " . get_option('time_format'), $TS_TablesWP_Styler_Modified);
				} else {
					$form_response['timestring']            = __("No Session Saved", "ts_visual_composer_extend");                
				}
				wp_send_json($form_response);
				Exit();
			}
			
			function TS_TablesWP_Quick_File() {
				if (!isset($_GET['secret']) || $_GET['secret'] != md5( md5( AUTH_KEY . SECURE_AUTH_KEY ) . '-' . 'ts-advanced-tables') ) {
					wp_die(__("Invalid secret for export request!", "ts_visual_composer_extend"));
					Exit();
				}
				if (isset($_GET['action']) && $_GET['action'] == 'ts_tablestyler_export_file') {
					$TS_TablesWP_Styler_CodeCSS             = get_option('ts_tablesplus_extend_settings_exportcss', '');
					$TS_TablesWP_Styler_CodeJSON            = get_option('ts_tablesplus_extend_settings_exportjson', '');
					if (($TS_TablesWP_Styler_CodeCSS == null) || ($TS_TablesWP_Styler_CodeCSS == "")) {
						wp_redirect(admin_url('admin.php?page=TS_TablesWP_Styler'));
						Exit();
					}
					update_option('ts_tablesplus_extend_settings_codecss',					'');
					update_option('ts_tablesplus_extend_settings_codejson',       			'');
					$TS_TablesWP_Styler_Name 				= "Export";
					$TS_TablesWP_Styler_Date				= current_time('timestamp', 0);
					$TS_TablesWP_Styler_Date				= date('Y-m-d @H-i-s', $TS_TablesWP_Styler_Date);
					$TS_TablesWP_Styler_Date 				= str_replace(' ', '_', $TS_TablesWP_Styler_Date);
					header('Content-Description: File Transfer');
					header('Content-Type: application/txt');
					header('Content-Disposition: attachment; filename="Tablenator_Styler_-_' . $TS_TablesWP_Styler_Name . '_(' . $TS_TablesWP_Styler_Date . ').css"');
					header('Content-Transfer-Encoding: binary');
					header('Expires: 0');
					header('Cache-Control: must-revalidate');
					header('Pragma: public');
					header("Content-Type: application/force-download");
					echo $TS_TablesWP_Styler_CodeCSS;
					Exit();
				} else {
					wp_redirect(admin_url('admin.php?page=TS_TablesWP_Styler'));
					Exit();
				}
			}
			
			function TS_TablesWP_Quick_Delete() {
				$error_pass 					    		= true;
				$error_code						    		= array();
				// Default Response Holder
				$form_response                  			= array(
					'success'                     			=> $error_pass,
					'message'								=> '',
				);
				// Check for NONCE Compliance
				if (empty($_POST) || !wp_verify_nonce($_POST['sessionnonce'], 'ts-advanced-tables')) {				   
					$error_code['nonce']					= (isset($_POST['error_nonce']) ? $_POST['error_nonce'] : '');
					$error_pass 							= false;
					$form_response['message']				= $error_code;
				} else {
					update_option('ts_tablesplus_extend_settings_styletime',    	'');
					update_option('ts_tablesplus_extend_settings_stylecss',     	'');
					update_option('ts_tablesplus_extend_settings_stylejson',    	'');
					update_option('ts_tablesplus_extend_settings_exporttime',     	'');
					update_option('ts_tablesplus_extend_settings_exportcss',      	'');
					update_option('ts_tablesplus_extend_settings_exportjson',     	'');
				}
				// AJAX Return Message
				$form_response['success']					= $error_pass;
				wp_send_json($form_response);
				Exit();
			}
		}
	}
	if (class_exists('TS_TablesWP_Styler')) {
		$TS_TablesWP_Styler = new TS_TablesWP_Styler;
	}	
?>