<?php
	global $TS_ADVANCED_TABLESWP;
	
	// Define Shortcode (Fields) Default Settings
	function TS_TablesWP_Generator_Default($shortcode) {
		global $TS_ADVANCED_TABLESWP;
		if ($shortcode == "TS_Advanced_Tables") {
			return array(
				'source'							=> 'internal',
				'id'								=> '',
				// Google Spreadsheet
				'google_id'							=> '',
				'google_sheet'						=> 1,
				'google_locale'						=> 'en-US',
				'google_thousand'					=> ',',
				'google_decpoint'					=> '.',
				// Show Additional Table Data
				'show_name'							=> 'false',
				'show_info'							=> 'false',
				'show_comments'				 		=> 'false',
				'show_indicator'					=> 'true',
				// Comment Date + Time Holder
				'comments_date_check'				=> 'false',		// ddd:
				'comments_date_tooltip'				=> 'false',
				'comments_time_check'				=> 'false',		// ttt:
				'comments_time_tooltip'				=> 'false',
				// Preloader Settings
				'preloader_use'						=> 'false',
				'preloader_style'					=> 0,
				'preloader_background'				=> '#ffffff',
				// Exclusions
				'exclude_rows'						=> '',
				'exclude_columns'					=> '',
				// Header Settings
				'header_use'						=> 'true',
				'header_rows'						=> 1,
				// Footer Settings
				'footer_use'						=> 'false',
				'footer_rows'						=> 1,
				// Table Scope
				'table_formatting'					=> 'metadata',	// metadata, custom, none
				'table_scope'						=> 'none',
				'table_merged'						=> 'false',
				'table_shortcodes'					=> 'false',
				// Width Settings
				'width_type'						=> 'percent',	// percent, fixed, maximum, none
				'width_percent'						=> 100,
				'width_fixed'						=> 800,
				'width_maximum'						=> 800,
				// Responsive Settings
				'responsive_type'					=> 'none',
				'responsive_switch'					=> 640,
				'responsive_parentwidth'			=> 'true',
				'responsive_heighttype'				=> 'none',
				'responsive_heightpixel'			=> 800,
				'responsive_heightpercent'			=> 75,			
				// Column Widths
				'columns_widthlimit'				=> 'true',
				'columns_widthmin'					=> 120,
				'columns_widthmax'					=> 300,
				// Column Formats
				'format_html'						=> '',
				'format_date'						=> '',
				'format_time'						=> '',
				'format_number'						=> '',
				'format_currency'					=> '',
				'format_percent'					=> '',
				'format_numeric_html'				=> '',
				'format_natural_simple'				=> '',
				'format_natural_nohtml'				=> '',
				'format_natural_nocase'				=> '',
				// Custom Format Settings
				'numbers_horizontal'				=> '',
				'numbers_vertical'					=> '',					
				'numbers_locale'					=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_EditorLocale,
				'numbers_symbol'					=> '36',
				'numbers_space_percent'				=> ($TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_PercentSpace == true ? 'true' : 'false'),
				'numbers_space_currency'			=> ($TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_CurrencySpace == true ? 'true' : 'false'),
				'numbers_placement'					=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_CurrencyPlacement,
				'numbers_decimals_percent'			=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsPercent,
				'numbers_decimals_numeric'			=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsNumeric,
				'numbers_decimals_currency'			=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsCurrency,
				'numbers_date'						=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatDate,
				'numbers_time_hours'				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeHours,
				'numbers_time_minutes'				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeMinutes,
				'numbers_time_seconds'				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeSeconds,
				'numbers_header'					=> 'false',
				'numbers_footer'					=> 'true',
				'numbers_exclude'					=> '',
				// Tooltip Settings
				'tooltip_position'					=> 'top',
				'tooltip_style'						=> 'krauttipster-black',
				'tooltip_animation'					=> 'fade',
				'tooltip_offsetx'					=> 0,
				'tooltip_offsety'					=> 0,
				// TableSaw Settings
				'tablesaw_scope'					=> 'swipe',
				'tablesaw_persist'					=> '1',
				'tablesaw_fixwidth'					=> 0,
				'tablesaw_sort'						=> 'false',
				'tablesaw_sortswitch'				=> 'false',
				'tablesaw_initial'					=> 1,
				'tablesaw_order'					=> 'ascending',
				'tablesaw_noorder'					=> '',
				'tablesaw_modeswitch'				=> 'false',
				'tablesaw_modeexclude'				=> '',
				'tablesaw_minimap'					=> 'true',
				'tablesaw_text_reponsive'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawResponsive']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawResponsive'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawResponsive']),
				'tablesaw_text_stack'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawStack']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawStack'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawStack']),
				'tablesaw_text_swipe'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSwipe']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSwipe'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawSwipe']),
				'tablesaw_text_toggle'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawToggle']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawToggle'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawToggle']),
				'tablesaw_text_columns'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawColumns']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawColumns'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawColumns']),
				'tablesaw_text_error'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawError']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawError'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawError']),
				'tablesaw_text_sort'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSort']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSort'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawSort']),
				// FooTable Settings
				'footable_sort'						=> 'false',
				'footable_initial'					=> 1,
				'footable_order'					=> 'ASC',
				'footable_noorder'					=> '',
				'footable_lengthmenu'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthMenu']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthMenu'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableLengthMenu']),
				'footable_lengthall'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthAll']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthAll'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableLengthAll']),
				'footable_pages'					=> 'false',
				'footable_pagesspot'				=> 'center',
				'footable_countformat'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableCountFormat']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableCountFormat'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableCountFormat']),
				'footable_length'					=> 10,
				'footable_lengthcustom'				=> 10,
				'footable_lengthoptions'			=> '5,10,15,25,50,75,100,150,200',
				'footable_search'					=> 'false',
				'footable_searchspot'				=> 'right',
				'footable_searchmin'				=> 3,
				'footable_placeholder'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footablePlaceholder']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footablePlaceholder'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footablePlaceholder']),
				'footable_noresults'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableNoResults']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableNoResults'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableNoResults']),
				'footable_nosearch'					=> '',
				'footable_parentwidth'				=> 'true',
				'footable_cascade'					=> 'true',
				'footable_notever'					=> '',
				'footable_collapsed'				=> '',
				'footable_breakxs'					=> '',
				'footable_breaksm'					=> '',
				'footable_breakmd'					=> '',
				'footable_breaklg'					=> '',
				// Tabulator Settings
				'tabulator_layout'					=> 'fitColumns',
				'tabulator_responsive'				=> 'collapse',
				'tabulator_priority'				=> '1,5,4,2,3',
				'tabulator_notever'					=> '',
				'tabulator_freezerows'				=> '',
				'tabulator_freezecols'				=> '',
				'tabulator_virtualdom'				=> 'true',
				'tabulator_sorting'					=> 'false',
				'tabulator_nosearch'				=> '',
				'tabulator_paginate'				=> 'false',
				'tabulator_pagesize'				=> 10,
				// Datatables Settings
				'datatables_theme'					=> 'default',
				'datatables_search'					=> 'false',
				'datatables_nosearch'				=> '',
				'datatables_sort'					=> 'false',
				'datatables_inital'					=> 1,
				'datatables_order'					=> 'asc',
				'datatables_noorder'				=> '',
				'datatables_info'					=> 'true',
				'datatables_pages'					=> 'false',
				'datatables_length'					=> 10,
				'datatables_lengthcustom'			=> 10,
				'datatables_lengthoptions'			=> '5,10,15,25,50,75,100,150,200',
				'datatables_pagetype'				=> 'simple_numbers',
				'datatables_topfixed'				=> 'false',
				'datatables_topoffset'				=> 0,
				'datatables_bottomfixed'			=> 'false',
				'datatables_bottomoffset'			=> 0,
				'datatables_fixzindex'				=> 9999,
				'datatables_buttons'				=> 'false',
				'datatables_printshow'				=> 'true',
				'datatables_printtext'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrint']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrint'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePrint']),
				'datatables_pdfshow'				=> 'true',
				'datatables_pdftext'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePDF']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePDF'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePDF']),
				'datatables_csvshow'				=> 'true',
				'datatables_csvtext'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCSV']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCSV'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableCSV']),
				'datatables_excelshow'				=> 'true',
				'datatables_exceltext'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableExcel']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableExcel'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableExcel']),
				'datatables_copyshow'				=> 'true',
				'datatables_copytext'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCopy']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCopy'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableCopy']),
				'datatables_togglerow'				=> 'false',
				'datatables_always'					=> '',
				'datatables_collapsed'				=> '',
				'datatables_notever'				=> '',
				'datatables_groupit'				=> 'true',
				'datatables_desktopnot'				=> '',
				'datatables_tabletnot'				=> '',
				'datatables_tabletnot_l'			=> '',
				'datatables_tabletnot_p'			=> '',
				'datatables_mobilenot'				=> '',
				'datatables_mobilenot_l'			=> '',
				'datatables_mobilenot_p'			=> '',
				'datatable_text_processing'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableProcessing']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableProcessing'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableProcessing']),
				'datatable_text_lengthmenu'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthMenu']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthMenu'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLengthMenu']),
				'datatable_text_lengthall'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthAll']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthAll'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLengthAll']),
				'datatable_text_infomain'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoMain']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoMain'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoMain']),
				'datatable_text_infoempty'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoEmpty']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoEmpty'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoEmpty']),
				'datatable_text_infofiltered'		=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoFiltered']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoFiltered'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoFiltered']),
				'datatable_text_search'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableSearch']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableSearch'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableSearch']),
				'datatable_text_placeholder'		=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePlaceholder']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePlaceholder'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePlaceholder']),
				'datatable_text_zerorecords'		=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableZeroRecords']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableZeroRecords'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableZeroRecords']),
				'datatable_text_first'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableFirst']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableFirst'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableFirst']),
				'datatable_text_previous'			=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrevious']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrevious'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePrevious']),
				'datatable_text_next'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableNext']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableNext'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableNext']),
				'datatable_text_last'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLast']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLast'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLast']),
				// Export Settings
				'datatables_export_size'			=> 'LEGAL',			// LEGAL, A4
				'datatables_export_orient'			=> 'landscape',		// portrait, landscape
				'datatables_export_font'			=> 'Roboto',		// Roboto, DroidKufi
				'datatables_export_head'			=> 'true',
				'datatables_export_foot'			=> 'true',
				'datatables_export_filter'			=> 'false',
				// Styling Settings
				'styling_customize'					=> 'false',
				'styling_stlyerid'					=> '',
				'styling_size_head'					=> 16,
				'styling_size_body'					=> 13,
				'styling_size_foot'					=> 16,					
				'styling_weight_head'				=> 'bold',
				'styling_weight_body'				=> 'normal',
				'styling_weight_foot'				=> 'bold',					
				'styling_transform_head'			=> 'none',
				'styling_transform_body'			=> 'none',
				'styling_transform_foot'			=> 'none',
				'styling_family_head'				=> 'inherit',
				'styling_family_body'				=> 'inherit',
				'styling_family_foot'				=> 'inherit',
				'styling_color_head'				=> '#696969',
				'styling_color_bodyodd'				=> '#696969',
				'styling_color_bodyeven'			=> '#696969',					
				'styling_color_foot'				=> '#696969',
				'styling_background_head'			=> '#e6e6e6',
				'styling_background_bodyodd'		=> '#ffffff',
				'styling_background_bodyeven'		=> '#f9f9f9',
				'styling_background_foot'			=> '#e6e6e6',
				// Conditional Output
				'limitvisibility'					=> 'false',
				'processing'						=> 'server', 		// server, client, shortcode, function
				'dependency'						=> 'always', 		// datetime, dateonly, timeonly, weekdays, always
				'timezone'							=> 'WP',
				'datetime_range'					=> '|',
				'dateonly_range'					=> '|',
				'timeonly_period'					=> '96,192',
				'timeonly_weekend'					=> 'true',
				'mondays_scope'						=> 'full',
				'mondays_period'					=> '96,192',
				'tuesdays_scope'					=> 'full',
				'tuesdays_period'					=> '96,192',
				'wednesdays_scope'					=> 'full',
				'wednesdays_period'					=> '96,192',
				'thursdays_scope'					=> 'full',
				'thursdays_period'					=> '96,192',
				'fridays_scope'						=> 'full',
				'fridays_period'					=> '96,192',
				'saturdays_scope'					=> 'none',
				'saturdays_period'					=> '108,180',
				'sundays_scope'						=> 'none',
				'sundays_period'					=> '144,216',
				'callback_shortcode'				=> '',
				'callback_function'					=> '',
				'conditionals'						=> '',
				// Other Settings
				'margin_bottom'						=> 0,
				'margin_top' 						=> 0,
				'el_id' 							=> '',
				'el_class'                  		=> '',
				'css'								=> '',
			);
		} else {
			return array();
		}
	}

	function TS_TablesWP_Generator_Fields() {
		global $TS_ADVANCED_TABLESWP;
		
		// Retrieve Required Settings
		$TS_ADVANCED_TABLESWP->TS_TablesWP_GetTablesCoreData();
		
		// Create Select Options for Table ID's
		$select_tables							= array();
		if (count($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables) > 0) {
			foreach ($TS_ADVANCED_TABLESWP->TS_TablesWP_Custom_Tables as $tables => $table) {
				$select_tables[] 				= $table['id'];
			}
		}
		$select_tables							= implode(",", $select_tables);

		// Create Fallback Selection array
		$select_fallback						= array(
			__("No selection available.", "ts_visual_composer_extend") 	=> "",
		);
		
		// Retrieve Required Variables
		$current_local 							= current_time('timestamp', 0);
		$current_moment							= TS_TablesWP_CreateTimeValueArray($current_local);
		$current_time							= date('h:i A', mktime($current_moment['hours'] + 1, 0, 0));
		$current_offset							= get_option('gmt_offset');

		if (class_exists('CSF')) {
			$prefix_short_opts           		= 'ts-tablenator-shortcode';

			CSF::createShortcoder($prefix_short_opts, array(
				'button_title' 					=> __( "Tablenator - Advanced Tables for WordPress", "ts_visual_composer_extend" ),
				'select_title'					=> __( "Select Shortcode", "ts_visual_composer_extend" ),
				'insert_title'					=> __( "Add New Shortcode", "ts_visual_composer_extend" ),
				'show_in_editor'				=> true, //$TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_TinyMCEAllow,
				'show_in_custom'				=> true,
				'defaults'						=> TS_TablesWP_Generator_Default('TS_Advanced_Tables'),
				'add_to_gutenberg'				=> false,
				'gutenberg'      				=> array(
					'title'        					=> __( "Tablenator Shortcode", "ts_visual_composer_extend" ),
					'description'  					=> __( "Tablenator Shortcode Block", "ts_visual_composer_extend" ),
					'icon'         					=> 'editor-table',
					'category'     					=> 'widgets',
					'keywords'     					=> array( 'tablenator', 'shortcode', 'generate' ),
					'placeholder'  					=> __( 'Add shortcode here ...', 'ts_visual_composer_extend' ),
				)
			));
			
			// Create Shortcode Generator Options
			CSF::createSection($prefix_short_opts, array(
				'title'     					=> __( "Table Shortcode", "ts_visual_composer_extend" ),
				'view'      					=> 'normal',
				'shortcode'						=> 'TS_Advanced_Tables',
				'defaults'						=> TS_TablesWP_Generator_Default('TS_Advanced_Tables'),
				'fields'    					=> array(
					// Table Selection + Output
					array(
						'id'					=> 'defaultsgenerator',
						'type'					=> 'defaultsgenerator',
						'value'					=> json_encode(TS_TablesWP_Generator_Default('TS_Advanced_Tables'), JSON_UNESCAPED_UNICODE),
						'generator'				=> 'ts-tablenator-shortcode',
					),
					array(
						"type"					=> "heading",
						"content"				=> __( "Table Selection + Scope", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'id',
						'type'  				=> 'tablenatorpicker',
						'title' 				=> __( "Table: ID", "ts_visual_composer_extend" ),
						'help'  				=> __( "Select the advanced table you want to display.", "ts_visual_composer_extend" ),
						'chosen'				=> 'true',
					),
					array(
						'id'    				=> 'table_formatting',
						'type'  				=> 'select',
						'title' 				=> __( "Table: Formatting Source", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Sources) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Sources : $select_fallback),
						'default'  				=> 'metadata',
						'chosen'            	=> true,
						'dependency'   			=> array('id', 'any', $select_tables),
						'help'  				=> __( "Define if and what formatting data should be used for table cells.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'table_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Table: Theme / Scope", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TableThemes) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TableThemes : $select_fallback),
						'default'  				=> 'none',
						'chosen'            	=> true,
						'dependency'   			=> array('id', 'any', $select_tables),
						'help'  				=> __( "Define what style and/or type of table you want to render.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'datatables_theme',
						'type'  				=> 'select',
						'title' 				=> __( "Table: Color Theme", "ts_visual_composer_extend" ),
						'options'				=> array(
							"default" 						=> __( "Default", "ts_visual_composer_extend" ),
							"yellow" 						=> __( "Yellow", "ts_visual_composer_extend" ),
							"blue"							=> __( "Blue", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'default',
						'chosen'            	=> true,
						'dependency'   			=> array('table_scope', '==', 'datatable'),
						'help'  				=> __( "Define the color theme to be used for the table.", "ts_visual_composer_extend" ),
					),
					// Table Exclusions
					array(
						'id' 					=> 'exclude_rows',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Exclude: Rows", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the rows within the table dataset you want to exclude when rendering the table; separate rows with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'exclude_columns',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Exclude: Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns within the table dataset you want to exclude when rendering the table; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|none,minimal,simplelittle,blank,tablesaw'),
					),
					// Table Extra Output
					array(
						"type"					=> "subheading",
						"content"				=> __( "Other Output Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'show_name',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Show Name", "ts_visual_composer_extend" ),					
						'default' 				=> 'false',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Switch the toggle if you want to show the table name above the table.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'show_info',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Show Info", "ts_visual_composer_extend" ),					
						'default' 				=> 'false',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Switch the toggle if you want to show the optional table information above the table.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'show_comments',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Show Comments", "ts_visual_composer_extend" ),					
						'default' 				=> 'false',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Switch the toggle if you want to show applied cell comments via tooltip when hovering over a cell.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'show_indicator',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Show Indicator", "ts_visual_composer_extend" ),					
						'default' 				=> 'true',
						'dependency'   			=> array('id|show_comments', 'any|==', $select_tables . '|true'),
						'help' 					=> __( "Switch the toggle if you want to show a tooltip indicator icon for all cells with a comment.", "ts_visual_composer_extend" ),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "Based on the content a shortcode will result in after getting processed, the table responsiveness and/or other features, such as sorting or filtering, might be negatively impacted. It is best to only use shortcodes if they generate basic cell content such as numbers. The more cells the table contains, the longer the table rendering will take, as every cell must be checked for shortcode content first, which requires additional processing time.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'table_shortcodes',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Shortcode Content", "ts_visual_composer_extend" ),					
						'default' 				=> 'false',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Define if the plugin should check table cells for shortcode content and process them accordingly.", "ts_visual_composer_extend" ),
					),
					// Preloader Settings
					array(
						"type"					=> "subheading",
						"content"				=> __( "Preloader Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'preloader_use',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Preloader: Show Animation", "ts_visual_composer_extend" ),
						'default' 				=> 'false',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Switch the toggle if you want to show a preloader animation while the table is rendering; useful for large tables with advanced features.", "ts_visual_composer_extend" ),
					),						
					array(
						'id'      				=> 'preloader_style',
						'type'    				=> 'preloaders',
						'generator'				=> 'ts-tablenator-shortcode',
						'title'   				=> __( "Preloader: Style", "ts_visual_composer_extend" ),
						'default' 				=> 0,
						'shownone'				=> 'false',
						'dependency'   			=> array('id|preloader_use', 'any|==', $select_tables . '|true'),
						'help'					=> __( "Select the style for the preloader animation to be shown while the table is rendering.", "ts_visual_composer_extend" ),
					),					
					array(
						'id'      				=> 'preloader_background',
						'type'    				=> 'color',
						'title'   				=> __( "Preloader: Background Color", "ts_visual_composer_extend" ),
						'default' 				=> 'rgba(255, 255, 255, 0.90)',
						'rgba'    				=> true,
						'dependency'   			=> array('id|preloader_use', 'any|==', $select_tables . '|true'),
						'help'					=> __( "Define the background color for the preloader container.", "ts_visual_composer_extend" ),
					),
					// Header + Footer Settings
					array(
						"type"					=> "subheading",
						"content"				=> __( "Header + Footer Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'header_use',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Header: Create Header", "ts_visual_composer_extend" ),				
						'default' 				=> 'true',
						'dependency'   			=> array('id', 'any', $select_tables),
						'help' 					=> __( "Switch the toggle if you want to use some rows as official table header.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'header_rows',
						'type'    				=> 'spinner',
						'title'   				=> __( "Header: Rows", "ts_visual_composer_extend" ),
						'default' 				=> '1',						
						'help'    				=> __( "Define the number of top rows that should be used as header.", "ts_visual_composer_extend" ),
						'min' 					=> '1',
						'max'					=> '3',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|header_use', 'any|==', $select_tables . '|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "The Footable script is currently unable to handle footer rows, as the footer is a reserved space for the paging component only.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id'      				=> 'footer_use',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Footer: Create Footer", "ts_visual_composer_extend" ),			
						'default' 				=> 'false',
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|none,minimal,simplelittle,blank,tablesaw,datatable'),
						'help' 					=> __( "Switch the toggle if you want to use the last row as official table footer.", "ts_visual_composer_extend" ),
					),
					// Column Format Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Columns Format Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "Advanced table scripts will attempt to parse the column content to determine the format of the content, which is relevant for any sorting feature to work correctly. Using the inputs below, you can manually assign columns to specific formats.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'danger',
						'content' 				=> __( "The FooTable script requires you to manually assign each column to a specific format, in order to ensure that the content is formatted (and sorted) correctly.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),					
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Standard Column Formats", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'format_html',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: HTML/Text Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain HTML and/or text content only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_number',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Numeric Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain standard numbers only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_currency',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Currency Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain currency numbers only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_percent',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Percent Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain percent numbers only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_date',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Date Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain date strings only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_time',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Time Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain time strings only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'format_images_columns',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Image Content", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain images only that also have valid ALT tags; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|datatable,footable,tablesaw'),
					),
					// Hybrid Column Formats
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Hybrid Column Formats", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'format_natural_simple',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Alpha-Numeric (Case Sensitive)", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain alpha-numeric strings only (normal sorting); separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'format_natural_nocase',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Alpha-Numeric (Case Insensitive)", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain alpha-numeric strings only (case insensitive sorting); separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'format_numeric_html',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Columns: Numeric-HTML", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that contain numeric strings within HTML tags only; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					// Table Custom Formatting
					array(
						'type'					=> 'heading',
						'content'				=> __( "Custom Format Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "The following settings will replace any custom formatting added to individal table cells, using the toolbar in the table editor. Formats will instead be applied based on the column format assignments made above.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Content Alignments", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'    				=> 'numbers_horizontal',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Horizontal Alignment", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Alignment_Horizontal) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Alignment_Horizontal : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the horizontal alignment for any cell content.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'numbers_vertical',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Vertical Alignment", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Alignment_Vertical) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Alignment_Vertical : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the vertical alignment for any cell content.", "ts_visual_composer_extend" ),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Currency Formatting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'    				=> 'numbers_locale',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Cell Locale", "ts_visual_composer_extend" ),
						'options'				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_NumbroJS_Locales,
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_EditorLocale,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the locale that should be used for any number formatting.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'numbers_symbol',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Currency Placement", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Currency_Placement) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Currency_Placement : $select_fallback),
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_CurrencyPlacement,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the placement of the currency symbol in relation to the value.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'numbers_space_currency',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Format: Currency Space", "ts_visual_composer_extend" ),
						'default' 				=> ($TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_CurrencySpace == true ? 'true' : 'false'),				
						'help' 					=> __( "Switch the toggle if you want to add a space between the currency symbol and the value.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_decimals_currency',
						'type'    				=> 'spinner',
						'title'   				=> __( "Format: Currency Decimals", "ts_visual_composer_extend" ),
						'default' 				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsCurrency,						
						'help'    				=> __( "Define the number of decimals to be used for currency values.", "ts_visual_composer_extend" ),
						'min' 					=> '0',
						'max'					=> '6',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Percentage Formatting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_space_percent',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Format: Percent Space", "ts_visual_composer_extend" ),
						'default' 				=> ($TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_PercentSpace == true ? 'true' : 'false'),				
						'help' 					=> __( "Switch the toggle if you want to add a space between the percentage symbol and the value.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_decimals_percent',
						'type'    				=> 'spinner',
						'title'   				=> __( "Format: Percent Decimals", "ts_visual_composer_extend" ),
						'default' 				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsPercent,						
						'help'    				=> __( "Define the number of decimals to be used for percentage values.", "ts_visual_composer_extend" ),
						'min' 					=> '0',
						'max'					=> '6',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Numbers Formatting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_decimals_numeric',
						'type'    				=> 'spinner',
						'title'   				=> __( "Format: Numbers Decimals", "ts_visual_composer_extend" ),
						'default' 				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DecimalsPercent,						
						'help'    				=> __( "Define the number of decimals to be used for standard numeric values.", "ts_visual_composer_extend" ),
						'min' 					=> '0',
						'max'					=> '6',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Date + Time Formatting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'    				=> 'numbers_date',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Dates", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Dates) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Dates : $select_fallback),
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatDate,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the desired format for all date values.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'numbers_time_hours',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Hours", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Hours) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Hours : $select_fallback),
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeHours,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the desired format for hours in all time values.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'numbers_time_minutes',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Minutes", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Minutes) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Minutes : $select_fallback),
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeMinutes,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the desired format for minutes in all time values.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'numbers_time_seconds',
						'type'  				=> 'select',
						'title' 				=> __( "Format: Seconds", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Seconds) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Format_Seconds : $select_fallback),
						'default'  				=> $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FormatTimeSeconds,
						'chosen'				=> true,
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
						'help'  				=> __( "Define the desired format for seconds in all time values.", "ts_visual_composer_extend" ),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Other Formatting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_header',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Format: Process Header", "ts_visual_composer_extend" ),
						'default' 				=> 'false',
						'help' 					=> __( "Switch the toggle if you want to apply the formatting to header cells as well.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id'      				=> 'numbers_footer',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Format: Process Footer", "ts_visual_composer_extend" ),
						'default' 				=> 'true',
						'help' 					=> __( "Switch the toggle if you want to apply the formatting to footer cells as well.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					array(
						'id' 					=> 'numbers_exclude',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Format: Excluded Rows", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the rows that should be excluded from formatting; separate rows with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_formatting', 'any|==', $select_tables . '|custom'),
					),
					// Table Feature Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Table Features", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'    				=> 'responsive_type',
						'type'  				=> 'select',
						'title' 				=> __( "Table: Responsiveness", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TableResponsive) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TableResponsive : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|none,minimal,simplelittle,blank'),
						'help'  				=> __( "Define what type of responsive behavior should be applied to the table.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'responsive_switch',
						'type'    				=> 'slider',
						'title'   				=> __( "Table: Responsive Trigger", "ts_visual_composer_extend" ),
						'default' 				=> '640',					  
						'help'    				=> __( "Select the table width at which the table should switch into responsive mode.", "ts_visual_composer_extend" ),
						'min' 					=> '360',
						'max'					=> '1920',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|table_scope|responsive_type', 'any|any|any', $select_tables . '|none,minimal,simplelittle,blank|tiles,stack,split,flexflow,flexflip'),
					),
					array(
						'id'      				=> 'tablesaw_sortswitch',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Table: Watch Table Width", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to use the actual table width as responsive target; otherwise, the available browser (window) width will be used instead.", "ts_visual_composer_extend" ),
					  'dependency'   			=> array('id|table_scope|responsive_type', 'any|any|any', $select_tables . '|none,minimal,simplelittle,blank|tiles,stack,split,flexflow,flexflip'),
					),
					array(
						'id'    				=> 'responsive_heighttype',
						'type'  				=> 'select',
						'title' 				=> __( "Table: Maximum Height", "ts_visual_composer_extend" ),
						'options'				=> array(
							"none"							=> __( "No Maximum Height", "ts_visual_composer_extend" ),
							"dynamic"						=> __( "Dynamic Maximum Height", "ts_visual_composer_extend" ),
							"fixed"							=> __( "Fixed Maximum Height", "ts_visual_composer_extend" ),	
						),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|responsive_type', 'any|any|any', $select_tables . '|none,minimal,simplelittle,blank|tiles,stack'),
						'help'  				=> __( "Define if and how the maximum height for the adjusted table should be set.", "ts_visual_composer_extend" ),
					),
					array(
						'id'      				=> 'responsive_heightppercent',
						'type'    				=> 'slider',
						'title'   				=> __( "Table: Dynamic Height (Percent)", "ts_visual_composer_extend" ),
						'default' 				=> '75',						
						'help'    				=> __( "Define the maximum dynamic height for the adjusted table (as a percentage of visible browser height).", "ts_visual_composer_extend" ),
						'min' 					=> '50',
						'max'					=> '200',
						'step'					=> '1',
						'unit'					=> '%',
						'dependency'   			=> array('id|table_scope|responsive_type|responsive_heighttype', 'any|any|any|==', $select_tables . '|none,minimal,simplelittle,blank|tiles,stack|dynamic'),
					),
					array(
						'id'      				=> 'responsive_heightpixel',
						'type'    				=> 'slider',
						'title'   				=> __( "Table: Fixed Height (Pixel)", "ts_visual_composer_extend" ),
						'default' 				=> '800',						
						'help'    				=> __( "Define the maximum fixed height for the adjusted table.", "ts_visual_composer_extend" ),
						'min' 					=> '400',
						'max'					=> '1600',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|table_scope|responsive_type|responsive_heighttype', 'any|any|any|==', $select_tables . '|none,minimal,simplelittle,blank|tiles,stack|fixed'),
					),
					// Relevant Warnings
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "When using advanced table scripts, please ensure that you do not use merged cells within the last header row, the table body and the table footer, as advanced features such as sorting of columns do not work with merged cells.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|tablesaw,footable,datatable'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'danger',
						'content' 				=> __( "In order to use a table sorting routine, a table header is required to be present so that the sort controls can be attached correctly!", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|any|==', $select_tables . '|tablesaw,footable,datatable|false'),
					),
					// TableSaw Settings
					array(
						'type'					=> 'subheading',
						'content'				=> __( "TableSaw Column Sorting", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|tablesaw|true'),
					),
					array(
						'id'      				=> 'tablesaw_sort',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Sort: Column Sort", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a sort option for the table columns.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|tablesaw|true'),
					),
					array(
						'id'      				=> 'tablesaw_initial',
						'type'    				=> 'slider',
						'title'   				=> __( "Sort: Initial Column", "ts_visual_composer_extend" ),
						'default' 				=> '1',						  
						'help'    				=> __( "Define the column by which the table should be initially sorted by.", "ts_visual_composer_extend" ),						
						'min' 					=> '1',
						'max'					=> '99',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_scope|header_use|tablesaw_sort', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id'    				=> 'tablesaw_order',
						'type'  				=> 'select',
						'title' 				=> __( "Sort: Initial Order", "ts_visual_composer_extend" ),
						'options'				=> array(
							"ascending"						=> __( "Ascending", "ts_visual_composer_extend" ),
							"descending"					=> __( "Descending", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'ascending',						
						'help'  				=> __( "Define the initial sort order for the column defined above.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|header_use|tablesaw_sort', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id' 					=> 'tablesaw_noorder',
						'type' 					=> 'tageditor',
						'title' 				=> __( "Sort: Exclude Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns to be excluded from sort controls; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use|tablesaw_sort', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id'      				=> 'tablesaw_sortswitch',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Sort: Main Control", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide an additional main sort controls for all columns above the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use|tablesaw_sort', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "TableSaw Responsiveness", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),
					array(
						'id'    				=> 'tablesaw_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Responsiveness: Table Mode", "ts_visual_composer_extend" ),
						'options'				=> array(
							"swipe"							=> __( "Columns Swipe", "ts_visual_composer_extend" ),								
							"columntoggle"					=> __( "Columns Toggle", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'swipe',							
						'help'  				=> __( "Define what type of responsive table mode should be applied to the table.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),
					array(
						'id'      				=> 'tablesaw_modeswitch',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Responsiveness: Mode Switch", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide an option to the end user to switch between the different responsive modes.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),
					array(
						'id' 					=> 'tablesaw_persist',
						'type' 					=> 'tageditor',
						'title' 				=> __( "Responsiveness: Always Visible", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the persistent columns to be shown at all times; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'default'				=> '1',
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),						
					array(
						'id'      				=> 'tablesaw_fixwidth',
						'type'    				=> 'slider',
						'title'   				=> __( "Responsiveness: Persist Width", "ts_visual_composer_extend" ),
						'default' 				=> '0',						  
						'help'    				=> __( "Define the fixed width for the persistent columns that should be maintained; set to zero (0) for automatic adjustment. Using this option can cause display issues with narrow table widths.", "ts_visual_composer_extend" ),
						'min' 					=> '0',
						'max'					=> '400',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),						
					array(
						'id'      				=> 'tablesaw_minimap',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Responsiveness: Mini Map", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a visual indicator about visible and currently hidden columns.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|tablesaw'),
					),
					// Footable Settings
					array(
						'type'					=> 'subheading',
						'content'				=> __( "FooTable Column Sort", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id'      				=> 'footable_sort',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Sort: Column Sort", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a sort option for the table columns.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|footable|true'),
					),						
					array(
						'id'      				=> 'footable_initial',
						'type'    				=> 'slider',
						'title'   				=> __( "Sort: Initial Column", "ts_visual_composer_extend" ),
						'default' 				=> '1',						  
						'help'    				=> __( "Define the column by which the table should be initially sorted by.", "ts_visual_composer_extend" ),						
						'min' 					=> '1',
						'max'					=> '99',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_scope|header_use|footable_search', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id'    				=> 'footable_order',
						'type'  				=> 'select',
						'title' 				=> __( "Sort: Initial Order", "ts_visual_composer_extend" ),
						'options'				=> array(
							"ASC"							=> __( "Ascending", "ts_visual_composer_extend" ),
							"DESC"							=> __( "Descending", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'ASC',						
						'help'  				=> __( "Define the initial sort order for the column defined above.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|header_use|footable_search', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id' 					=> 'footable_noorder',
						'type' 					=> 'text',
						'title' 				=> __( "Sort: Exclude Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns to be excluded from sort controls; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use|footable_search', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "FooTable Pagination", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id'      				=> 'footable_pages',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Pagination: Use Pagination", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to paginate the tables if there are too many rows.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),	
					array(
						'id'    				=> 'footable_length',
						'type'  				=> 'select',
						'title' 				=> __( "Pagination: Page Length", "ts_visual_composer_extend" ),
						'options'				=> array(
							"5"								=> __( "5 Rows", "ts_visual_composer_extend" ),
							"10"							=> __( "10 Rows", "ts_visual_composer_extend" ),
							"25"							=> __( "25 Rows", "ts_visual_composer_extend" ),
							"50"							=> __( "50 Rows", "ts_visual_composer_extend" ),
							"75"							=> __( "75 Rows", "ts_visual_composer_extend" ),
							"100"							=> __( "100 Rows", "ts_visual_composer_extend" ),
							"custom"						=> __( "Custom Rows", "ts_visual_composer_extend" ),
						),
						'default'  				=> '10',						
						'help'  				=> __( "Define the number of rows to be shown per page.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|footable_pages', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id'      				=> 'footable_lengthcustom',
						'type'    				=> 'slider',
						'title'   				=> __( "Pagination: Custom Length", "ts_visual_composer_extend" ),
						'default' 				=> '10',						  
						'help'    				=> __( "Define the initial number of rows to be shown for each page.", "ts_visual_composer_extend" ),						
						'min' 					=> '5',
						'max'					=> '200',
						'step'					=> '1',
						'unit'					=> 'x',
						'dependency'   			=> array('id|table_scope|footable_pages|footable_length', 'any|==|==|==', $select_tables . '|footable|true|custom'),
					),
					array(
						'id' 					=> 'footable_lengthoptions',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						"default"				=> "5,10,15,25,50,75,100,150,200",
						'title' 				=> __( "Pagination: Length Options", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the options that should be made available to the viewer in order to change the pagination length.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|footable_pages', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id'    				=> 'footable_pagesspot',
						'type'  				=> 'select',
						'title' 				=> __( "Pagination: Controls Placement", "ts_visual_composer_extend" ),
						'options'				=> array(
							"left"							=> __( "Left", "ts_visual_composer_extend" ),
							"center"						=> __( "Center", "ts_visual_composer_extend" ),
							"right"							=> __( "Right", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'center',						
						'help'  				=> __( "Define the placement of the pagination controls below the table.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|footable_pages', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "FooTable Table Search", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id'      				=> 'footable_search',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Search: Table Search", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a search input for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),					
					array(
						'id'      				=> 'footable_searchmin',
						'type'    				=> 'slider',
						'title'   				=> __( "Search: Minimum Characters", "ts_visual_composer_extend" ),
						'default' 				=> '3',						  
						'help'    				=> __( "Define the minimum number of required characters for the search to initiate.", "ts_visual_composer_extend" ),						
						'min' 					=> '1',
						'max'					=> '6',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_scope|footable_search', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id'    				=> 'footable_searchspot',
						'type'  				=> 'select',
						'title' 				=> __( "Search: Placement", "ts_visual_composer_extend" ),
						'options'				=> array(
							"left"							=> __( "Left", "ts_visual_composer_extend" ),
							"center"						=> __( "Center", "ts_visual_composer_extend" ),
							"right"							=> __( "Right", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'right',			
						'help'  				=> __( "Define the placement of the search controls above the table.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|footable_search', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id' 					=> 'footable_nosearch',
						'type' 					=> 'text',
						'title' 				=> __( "Search: Exclude Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns to be excluded from the table search; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|footable_search', 'any|==|==', $select_tables . '|footable|true'),
					),
					// DataTable Settings
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Datatable Column Sort", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'      				=> 'datatables_sort',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Sort: Column Sort", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a sort option for the table columns.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use', 'any|==|==', $select_tables . '|datatable|true'),
					),						
					array(
						'id'      				=> 'datatables_initial',
						'type'    				=> 'slider',
						'title'   				=> __( "Sort: Initial Column", "ts_visual_composer_extend" ),
						'default' 				=> '1',						  
						'help'    				=> __( "Define the column by which the table should be initially sorted by.", "ts_visual_composer_extend" ),						
						'min' 					=> '1',
						'max'					=> '99',
						'step'					=> '1',
						'unit'					=> '',
						'dependency'   			=> array('id|table_scope|header_use|datatables_sort', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id'    				=> 'datatables_order',
						'type'  				=> 'select',
						'title' 				=> __( "Sort: Initial Order", "ts_visual_composer_extend" ),
						'options'				=> array(
							"asc"							=> __( "Ascending", "ts_visual_composer_extend" ),
							"desc"							=> __( "Descending", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'asc',					
						'help'  				=> __( "Define the initial sort order for the column defined above.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|header_use|datatables_sort', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatables_noorder',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Sort: Exclude Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns to be excluded from sort controls; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|header_use|datatables_sort', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Pagination", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_pages',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Pagination: Use Pagination", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to paginate the tables if there are too many rows.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),	
					array(
						'id'    				=> 'datatables_length',
						'type'  				=> 'select',
						'title' 				=> __( "Pagination: Page Length", "ts_visual_composer_extend" ),
						'options'				=> array(
							"5"								=> __( "5 Rows", "ts_visual_composer_extend" ),
							"10"							=> __( "10 Rows", "ts_visual_composer_extend" ),
							"25"							=> __( "25 Rows", "ts_visual_composer_extend" ),
							"50"							=> __( "50 Rows", "ts_visual_composer_extend" ),
							"75"							=> __( "75 Rows", "ts_visual_composer_extend" ),
							"100"							=> __( "100 Rows", "ts_visual_composer_extend" ),
							"custom"						=> __( "Custom Rows", "ts_visual_composer_extend" ),
						),
						'default'  				=> '10',					
						'help'  				=> __( "Define the number of rows to be shown per page.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|datatables_pages', 'any|==|==', $select_tables . '|datatable|true'),
					),						
					array(
						'id'      				=> 'datatables_lengthcustom',
						'type'    				=> 'slider',
						'title'   				=> __( "Pagination: Custom Length", "ts_visual_composer_extend" ),
						'default' 				=> '10',						  
						'help'    				=> __( "Define the initial number of rows to be shown for each page.", "ts_visual_composer_extend" ),
						'min' 					=> '5',
						'max'					=> '200',
						'step'					=> '1',
						'unit'					=> 'x',
						'dependency'   			=> array('id|table_scope|datatables_pages|datatables_length', 'any|==|==|==', $select_tables . '|datatable|true|custom'),
					),
					array(
						'id' 					=> 'datatables_lengthoptions',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						"default"				=> "5,10,15,25,50,75,100,150,200",
						'title' 				=> __( "Pagination: Length Options", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the options that should be made available to the viewer in order to change the pagination length.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_pages', 'any|==|==', $select_tables . '|datatable|true'),
					),						
					array(
						'id'    				=> 'datatables_pagetype',
						'type'  				=> 'select',
						'title' 				=> __( "Pagination: Controls Type", "ts_visual_composer_extend" ),
						'options'				=> array(
							"numbers"						=> __( "Numbers Only", "ts_visual_composer_extend" ),
							"simple"						=> __( "Simple", "ts_visual_composer_extend" ),
							"simple_numbers"				=> __( "Simple Numbers", "ts_visual_composer_extend" ),
							"full"							=> __( "Full", "ts_visual_composer_extend" ),
							"full_numbers"					=> __( "Full Numbers", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'simple_numbers',				
						'help'  				=> __( "Define the type and extent of the pagination controls.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|datatables_pages', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Table Search", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_search',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Search: Table Search", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a search input for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_nosearch',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Search: Exclude Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns to be excluded from the table search; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_search', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Datatable Columns Filter", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_filtercols',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Filter: Columns Filter", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide filter controls for each individual column.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_filterinput',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Filter: Text Input Controls", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that should receive a text input control for filtering.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_filtercols', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id' 					=> 'datatables_filterselect',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Filter: Select Controls (Single)", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that should receive a select control (single selection) for filtering.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_filtercols', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id' 					=> 'datatables_filtermultiple',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Filter: Select Controls (Multiple)", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that should receive a select control (multiple selections) for filtering.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_filtercols', 'any|==|==', $select_tables . '|datatable|true'),
					),
					// DataTable Export Options
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Export Options", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_buttons',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: Export Options", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide buttons to export the table content in various formats.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),						
					array(
						'id'      				=> 'datatables_printshow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: Print Button", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a print button for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'      				=> 'datatables_pdfshow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: PDF Button", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a PDF export button for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'      				=> 'datatables_excelshow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: Excel Button", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a Excel export button for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'      				=> 'datatables_csvshow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: CSV Button", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a CSV export button for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'      				=> 'datatables_copyshow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: Copy Button", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a copy to clipboard button for the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					// DataTable Export Settings
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Export Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'    				=> 'datatables_export_orient',
						'type'  				=> 'select',
						'title' 				=> __( "Export: Page Direction", "ts_visual_composer_extend" ),
						'options'				=> array(
							"landscape"						=> __( "Landscape", "ts_visual_composer_extend" ),
							"portrait"						=> __( "Portrait", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'landscape',				
						'help'  				=> __( "Define the vertical or horizontal alignment of the page (for PDF and/or printout export).", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'    				=> 'datatables_export_size',
						'type'  				=> 'select',
						'title' 				=> __( "Export: Page Size", "ts_visual_composer_extend" ),
						'options'				=> array(
							"LEGAL"							=> __( "Legal", "ts_visual_composer_extend" ),
							"A4"							=> __( "A4", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'LEGAL',				
						'help'  				=> __( "Define the paper size of the page (for PDF and/or printout export).", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|datatables_buttons', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id'    				=> 'datatables_export_font',
						'type'  				=> 'select',
						'title' 				=> __( "Export: Page Font", "ts_visual_composer_extend" ),
						'options'				=> array(
							"Roboto"						=> __( "Roboto (Latin Characters)", "ts_visual_composer_extend" ),
							"DroidKufi"						=> __( "DroidKufi (Arabic Characters)", "ts_visual_composer_extend" ),
						),
						'default'  				=> 'Roboto',				
						'help'  				=> __( "Define the font type to be used for the PDF table export; only one font type can be used per table export.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_pdfshow', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id'      				=> 'datatables_export_filter',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Export: Excel Filter", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to provide a showing summary below the table, updated after search or pagination changes.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_excelshow', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					// DataTable Other Settings
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Other Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_info',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "DataTable: Table Info", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to provide a showing summary below the table, updated after search or pagination changes.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_topfixed',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "DataTable: Fixed Header", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to fix the table header at the top of the screen when scrolling a large table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					// Footable Column Visibility Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Visibility Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "When assigning columns to the respective inputs below, please ensure that you do not define conflicting settings. Breakpoints are based on actual table width, and not available screen width.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_notever',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Removed Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will NEVER be shown; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_collapsed',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Collapsed Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns you want to initially collapse (toggle to show/hide content will be shown instead); separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),						
					array(
						'id'      				=> 'footable_parentwidth',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Visibility: Watch Table Width", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to use the actual table width as responsive target; otherwise, the available browser (window) width will be used instead.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),						
					array(
						'id'      				=> 'footable_cascade',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Visibility: Cascade Breakpoints", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to cascade the breakpoint settings below.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=> __( "Cascading means that if a column is set to be collapsed (for example) on medium size screens, it will automatically be collapsed on small and extra small screens as well. Without cascading, you can make a column hidden on medium size screens but show the same column on any smaller screens again.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Large Sized Devices", "ts_visual_composer_extend" ) . ' [x > ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableLarge . ']',
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_breaklg',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Large Devices", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will not be shown on large devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Medium Sized Devices", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableMedium . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableLarge . ']',
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_breakmd',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Medium Devices", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will be not be shown on medium sized devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Small Sized Devices", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableSmall . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableMedium . ']',
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_breaksm',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Small Devices", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will not be shown on small devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Extra Small Devices", "ts_visual_composer_extend" ) . ' [x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_FootableSmall . ']', 
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					array(
						'id' 					=> 'footable_breakxs',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Extra Small Devices", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will not be shown on extra small devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|footable'),
					),
					// Datatable Visibility Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Visibility Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "When assigning columns to the respective inputs below, please ensure that you do not define conflicting settings. For example, a column can either be collapsed or hidden at all times, but not both.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id'      				=> 'datatables_togglerow',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Visibility: Collapsed Toggle", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to toggle collapsed columns by clicking anywhere on the row, or just the dedicated toggle indicator.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_collapsed',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Collapsed Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns you want to initially collapse (toggle to show/hide content will be shown instead); separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_notever',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Removed Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will NEVER be shown; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),						
					array(
						'id' 					=> 'datatables_always',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Visible Columns", "ts_visual_composer_extend" ),
						'help' 					=> __( "Define the columns that will ALWAYS be shown; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),						
					array(
						'id' 					=> 'datatables_groupit',
						'type'    				=> 'buttonswitch',
						'title' 				=> __( "Visibility: Group Tablet + Mobile Formats", "ts_visual_composer_extend" ),
						'default' 				=> 'true',	
						'help' 					=> __( "Switch the toggle if you want to group tablet and mobile devices, or if you want to separate each into respective landscape and portrait formats.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),						
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Desktop Devices", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_desktopnot',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Desktops", "ts_visual_composer_extend" ) . ' [x > ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableTabletL . ']',
						'help' 					=> __( "Define the columns that will not be visible on desktop devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Tablet Devices", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_tabletnot',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Tablets", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileL . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableTabletL . ']',
						'help' 					=> __( "Define the columns that will not be visible on tablet devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|true'),
					),						
					array(
						'id' 					=> 'datatables_tabletnot_l',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Tablets (Landscape)", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableTabletP . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableTabletL . ']',
						'help' 					=> __( "Define the columns that will not be visible on tablet devices in landscape format; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|false'),
					),
					array(
						'id' 					=> 'datatables_tabletnot_p',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Tablets (Portrait)", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileL . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableTabletP . ']',
						'help' 					=> __( "Define the columns that will not be visible on tablet devices in portrait format; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|false'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "Mobile Devices", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|==', $select_tables . '|datatable'),
					),
					array(
						'id' 					=> 'datatables_mobilenot',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Mobile", "ts_visual_composer_extend" ) . ' [x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileL . ']',
						'help' 					=> __( "Define the columns that will not be visible on mobile devices; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id' 					=> 'datatables_mobilenot_l',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Mobile (Landscape)", "ts_visual_composer_extend" ) . ' [' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileP . ' < x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileL . ']',
						'help' 					=> __( "Define the columns that will not be visible on mobile devices in landscape format; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|false'),
					),
					array(
						'id' 					=> 'datatables_mobilenot_p',
						'type' 					=> 'tageditor',
						"delimiter"				=> ", ",
						"numbersonly"			=> "true",
						'title' 				=> __( "Visibility: Not On Mobile (Portrait)", "ts_visual_composer_extend" ) . ' [x &le; ' . $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_DatatableMobileP . ']',
						'help' 					=> __( "Define the columns that will not be visible on mobile devices in portrait format; separate columns with comma and use only numeric values.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_groupit', 'any|==|==', $select_tables . '|datatable|false'),
					),
					// Language Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Locale Text Strings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|tablesaw,footable,datatable'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=>  __( "Based on selections made in prior options, the plugin will use certain text strings when rendering some table features. If utilized, you can change those text strings using the inputs below.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|tablesaw,footable,datatable'),
					),
					array(
						'id'      				=> 'language_modify',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Language: Change Text Strings", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to change some of the text strings used on the frontend when rendering the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope', 'any|any', $select_tables . '|tablesaw,footable,datatable'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "TableSaw Text Strings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|tablesaw|true'),
					),
					array(
						'id' 					=> 'tablesaw_text_reponsive',
						'type' 					=> 'text',
						'title' 				=> __( "Mode Switch: Responsiveness", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawResponsive']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawResponsive'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawResponsive']),
						'dependency'   			=> array('id|table_scope|tablesaw_modeswitch|language_modify', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id' 					=> 'tablesaw_text_stack',
						'type' 					=> 'text',
						'title' 				=> __( "Mode Switch: Stack", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawStack']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawStack'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawStack']),
						'dependency'   			=> array('id|table_scope|tablesaw_modeswitch|language_modify', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id' 					=> 'tablesaw_text_swipe',
						'type' 					=> 'text',
						'title' 				=> __( "Mode Switch: Swipe", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSwipe']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSwipe'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawSwipe']),
						'dependency'   			=> array('id|table_scope|tablesaw_modeswitch|language_modify', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),
					array(
						'id' 					=> 'tablesaw_text_toggle',
						'type' 					=> 'text',
						'title' 				=> __( "Mode Switch: Toggle", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSort']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawSort'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawSort']),
						'dependency'   			=> array('id|table_scope|tablesaw_modeswitch|language_modify', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),						
					array(
						'id' 					=> 'tablesaw_text_sort',
						'type' 					=> 'text',
						'title' 				=> __( "Sort: Sort Columns", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawToggle']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawToggle'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawToggle']),
						'dependency'   			=> array('id|table_scope|tablesaw_modeswitch|language_modify', 'any|==|==|==', $select_tables . '|tablesaw|true|true'),
					),						
					array(
						'id' 					=> 'tablesaw_text_columns',
						'type' 					=> 'text',
						'title' 				=> __( "Other: Columns", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawColumns']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawColumns'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawColumns']),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|tablesaw|true'),
					),
					array(
						'id' 					=> 'tablesaw_text_error',
						'type' 					=> 'text',
						'title' 				=> __( "Other: No eligible columns.", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawError']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_TableSaw['tablesawError'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['tablesawError']),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|tablesaw|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "FooTable Text Strings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|footable|true'),
					),
					array(
						'id' 					=> 'footable_placeholder',
						'type' 					=> 'text',
						'title' 				=> __( "Search: Placeholder", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footablePlaceholder']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footablePlaceholder'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footablePlaceholder']),
						'dependency'   			=> array('id|table_scope|footable_search|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id' 					=> 'footable_noresults',
						'type' 					=> 'text',
						'title' 				=> __( "Search: No Results", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableNoResults']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableNoResults'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableNoResults']),
						'dependency'   			=> array('id|table_scope|footable_search|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id' 					=> 'footable_lengthall',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: All", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthAll']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthAll'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableLengthAll']),
						'dependency'   			=> array('id|table_scope|footable_pages|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id' 					=> 'footable_lengthmenu',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Show {LM} Entries", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthMenu']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableLengthMenu'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableLengthMenu']),
						'dependency'   			=> array('id|table_scope|footable_pages|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=>  __( "The {LM} placeholder in this language string will be replaced with the possible page length options of (5, 10, 25, ... etc.) and is required for the page length select option to be rendered correctly.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|footable_pages|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'id' 					=> 'footable_countformat',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Count Format", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableCountFormat']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_FooTable['footableCountFormat'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['footableCountFormat']),
						'dependency'   			=> array('id|table_scope|footable_pages|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=>  __( "The default count format uses the current page and total pages placeholders which are substituted at run time for the actual values. The below lists all available placeholders that you can use when supplying your own format.<br/><br/>{CP} - The current page.<br/>{TP} - The total number of pages available.<br/>{PF} - The first row number of the current page.<br/>{PL} - The last row number of the current page.<br/>{TR} - The total number of rows available.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|footable_pages|language_modify', 'any|==|==|==', $select_tables . '|footable|true|true'),
					),
					array(
						'type'					=> 'subheading',
						'content'				=> __( "DataTable Text Strings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id' 					=> 'datatable_text_processing',
						'type' 					=> 'text',
						'title' 				=> __( "General: Processing", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableProcessing']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableProcessing'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableProcessing']),
						'dependency'   			=> array('id|table_scope|language_modify', 'any|==|==', $select_tables . '|datatable|true'),
					),
					array(
						'id' 					=> 'datatable_text_search',
						'type' 					=> 'text',
						'title' 				=> __( "Search: Search All Entries:", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableSearch']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableSearch'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableSearch']),
						'dependency'   			=> array('id|table_scope|datatables_search|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_placeholder',
						'type' 					=> 'text',
						'title' 				=> __( "Search: Enter keyword here ...", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePlaceholder']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePlaceholder'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePlaceholder']),
						'dependency'   			=> array('id|table_scope|datatables_search|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_zerorecords',
						'type' 					=> 'text',
						'title' 				=> __( "Search: No Entries To Display!", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableZeroRecords']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableZeroRecords'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableZeroRecords']),
						'dependency'   			=> array('id|table_scope|datatables_search|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_lengthall',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: All", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthAll']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthAll'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLengthAll']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_lengthmenu',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Show _MENU_ Entries", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthMenu']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLengthMenu'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLengthMenu']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=>  __( "The _MENU_ placeholder in this language string will be replaced with the possible page length options of (5, 10, 25, ... etc.) and is required for the page length select option to be rendered correctly.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_infomain',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Showing _START_ to _END_ of _TOTAL_ Entries", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoMain']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoMain'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoMain']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=>  __( "This string gives information to the end user about the information that is currently on display on the page. The following tokens can be used in the string and will be dynamically replaced as the table display updates.<br/><br/>_START_ - Display index of the first record on the current page.<br/>_END_ - Display index of the last record on the current page.<br/>_TOTAL_ - Number of records in the table after filtering.<br/>_MAX_ - Number of records in the table without filtering.<br/>_PAGE_ - Current page number.<br/>_PAGES_ - Total number of pages of data in the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_infoempty',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: No Entries To Show!", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoEmpty']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoEmpty'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoEmpty']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_infofiltered',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: - filtered from _MAX_ records.", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoFiltered']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableInfoFiltered'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableInfoFiltered']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'info',
						'content' 				=>  __( "When a user filters the information in a table via search, this string is appended to the information summary to give an idea of how strong the filtering is. The token _MAX_ will be replaced with the number of total records in the table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_first',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: First", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableFirst']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableFirst'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableFirst']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_previous',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Previous", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrevious']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrevious'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePrevious']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_next',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Next", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableNext']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableNext'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableNext']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatable_text_last',
						'type' 					=> 'text',
						'title' 				=> __( "Pagination: Last", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLast']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableLast'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableLast']),
						'dependency'   			=> array('id|table_scope|datatables_pages|language_modify', 'any|==|==|==', $select_tables . '|datatable|true|true'),
					),
					array(
						'id' 					=> 'datatables_printtext',
						'type' 					=> 'text',
						'title' 				=> __( "Export: Print", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrint']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePrint'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePrint']),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_printshow|language_modify', 'any|==|==|==|==', $select_tables . '|datatable|true|true|true'),
					),
					array(
						'id' 					=> 'datatables_pdftext',
						'type' 					=> 'text',
						'title' 				=> __( "Export: PDF", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePDF']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatablePDF'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatablePDF']),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_pdfshow|language_modify', 'any|==|==|==|==', $select_tables . '|datatable|true|true|true'),
					),
					array(
						'id' 					=> 'datatables_exceltext',
						'type' 					=> 'text',
						'title' 				=> __( "Export: Excel", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableExcel']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableExcel'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableExcel']),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_excelshow|language_modify', 'any|==|==|==|==', $select_tables . '|datatable|true|true|true'),
					),
					array(
						'id' 					=> 'datatables_csvtext',
						'type' 					=> 'text',
						'title' 				=> __( "Export: CSV", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCSV']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCSV'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableCSV']),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_csvshow|language_modify', 'any|==|==|==|==', $select_tables . '|datatable|true|true|true'),
					),
					array(
						'id' 					=> 'datatables_copytext',
						'type' 					=> 'text',
						'title' 				=> __( "Export: Copy", "ts_visual_composer_extend" ),
						'default'				=> (isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCopy']) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Language_DataTable['datatableCopy'] : $TS_ADVANCED_TABLESWP->TS_TablesWP_Settings_Globals['translations']['datatableCopy']),
						'dependency'   			=> array('id|table_scope|datatables_buttons|datatables_copyshow|language_modify', 'any|==|==|==|==', $select_tables . '|datatable|true|true|true'),
					),
					// Style Settings
					array(
						'type'					=> 'heading',
						'content'				=> __( "Style Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'    				=> 'styling_customize',
						'type'  				=> 'select',
						'title' 				=> __( "Styling: Customizations", "ts_visual_composer_extend" ),
						'options'				=> array(
							"false" 						=> __("No Customizations", "ts_visual_composer_extend"),
							"true" 							=> __("Basic Customizations", "ts_visual_composer_extend"),
							"quicksave"						=> __("Load Styler Quick Save", "ts_visual_composer_extend"),
							"database" 						=> __("Load Styler Database Save", "ts_visual_composer_extend"),
						),
						'default'  				=> 'false',				
						'help'  				=> __( "Select the appropriate option if you want to adjust some basic styling attributes for the table or load a styler session.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "This selection will negate any style selections made in other tabs and the table will be rendered only with the styling settings done via the table style generator.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|any', $select_tables . '|quicksave,database'),
					),
					array(
						'id'    				=> 'styling_stylerid',
						'type'  				=> 'select',
						'title' 				=> __( "Styling: Styler Session", "ts_visual_composer_extend" ),
						'options'				=> TS_TablesWP_RetrieveStylerListing("codestar"),
						'default'  				=> '',				
						'help'  				=> __( "Select the styler session you want to load from the database and use with this table.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|database'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "If the style selected above should only apply to this particular table, you must use a unique ID or class name to be assigned to both this table and in the style generator.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|database'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "Any style settings done to individual cells using the table editor will overrule any of the global style settings made below.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'type'					=> 'heading',
						'content'				=> __( "Columns Width Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|any', $select_tables . '|true,false'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "In order to ensure at least a basic responsive behavior for the table, absolute fixed column widths are not possible, as the table must be able to adjust column widths based on the applied responsive behavior. But you can use the options below to at least define a desired minimum and maximum width for the columns, and the applied table theme or advanced table script will attempt to use those settings, if at all possible. Without any defined desired widths, the browser will determine all column widths based on content solely.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|any', $select_tables . '|true,false'),
					),
					array(
						'id'      				=> 'columns_widthlimit',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Columns: Desired Widths", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to assign desired minimum and maximum widths for columns within this table.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|styling_customize', 'any|any', $select_tables . '|true,false'),
					),
					array(
						'id'      				=> 'columns_widthmin',
						'type'    				=> 'spinner',
						'title'   				=> __( "Columns: Minimum Width", "ts_visual_composer_extend" ),
						'default' 				=> '100',						
						'help'    				=> __( "Define the desired minimum width for columns.", "ts_visual_composer_extend" ),
						'min' 					=> '120',
						'max'					=> '250',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|styling_customize|columns_widthlimit', 'any|any|==', $select_tables . '|true,false|true'),
					),
					array(
						'id'      				=> 'columns_widthmax',
						'type'    				=> 'spinner',
						'title'   				=> __( "Columns: Maximum Width", "ts_visual_composer_extend" ),
						'default' 				=> '300',						
						'help'    				=> __( "Define the desired maximum width for columns.", "ts_visual_composer_extend" ),
						'min' 					=> '250',
						'max'					=> '500',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|styling_customize|columns_widthlimit', 'any|any|==', $select_tables . '|true,false|true'),
					),
					array(
						'id'    				=> 'styling_family_head',
						'type'  				=> 'select',
						'title' 				=> __( "Table Head: Font Family", "ts_visual_composer_extend" ),
						'options'				=> TS_TablesWP_FontsArrayListing("codestar", true),
						'default'  				=> 'inherit',				
						'help'  				=> __( "Select the font family you want to apply to this table section.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'      				=> 'styling_size_head',
						'type'    				=> 'spinner',
						'title'   				=> __( "Table Head: Font Size", "ts_visual_composer_extend" ),
						'default' 				=> '16',						  
						'help'    				=> __( "Define the desired font size for the table header section.", "ts_visual_composer_extend" ),
						'min' 					=> '12',
						'max'					=> '36',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'    				=> 'styling_weight_head',
						'type'  				=> 'select',
						'title' 				=> __( "Table Head: Font Weight", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights : $select_fallback),
						'default'  				=> 'bold',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the font weight for the table header section.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'styling_transform_head',
						'type'  				=> 'select',
						'title' 				=> __( "Table Head: Text Transform", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the text transform property for the table header section.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'styling_family_body',
						'type'  				=> 'select',
						'title' 				=> __( "Table Body: Font Family", "ts_visual_composer_extend" ),
						'options'				=> TS_TablesWP_FontsArrayListing("codestar", true),
						'default'  				=> 'inherit',				
						'help'  				=> __( "Select the font family you want to apply to this table section.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'      				=> 'styling_size_body',
						'type'    				=> 'spinner',
						'title'   				=> __( "Table Body: Font Size", "ts_visual_composer_extend" ),
						'default' 				=> '13',						  
						'help'    				=> __( "Define the desired font size for the table body section.", "ts_visual_composer_extend" ),
						'min' 					=> '12',
						'max'					=> '24',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'    				=> 'styling_weight_body',
						'type'  				=> 'select',
						'title' 				=> __( "Table Body: Font Weight", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights : $select_fallback),
						'default'  				=> 'normal',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the font weight for the table body section.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'styling_transform_body',
						'type'  				=> 'select',
						'title' 				=> __( "Table Body: Text Transform", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the text transform property for the table body section.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'styling_family_foot',
						'type'  				=> 'select',
						'title' 				=> __( "Table Foot: Font Family", "ts_visual_composer_extend" ),
						'options'				=> TS_TablesWP_FontsArrayListing("codestar", true),
						'default'  				=> 'inherit',				
						'help'  				=> __( "Select the font family you want to apply to this table section.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'      				=> 'styling_size_foot',
						'type'    				=> 'spinner',
						'title'   				=> __( "Table Foot: Font Size", "ts_visual_composer_extend" ),
						'default' 				=> '16',						  
						'help'    				=> __( "Define the desired font size for the table footer section.", "ts_visual_composer_extend" ),
						'min' 					=> '12',
						'max'					=> '36',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
					),
					array(
						'id'    				=> 'styling_weight_foot',
						'type'  				=> 'select',
						'title' 				=> __( "Table Foot: Font Weight", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_FontWeights : $select_fallback),
						'default'  				=> 'bold',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the font weight for the table footer section.", "ts_visual_composer_extend" ),
					),
					array(
						'id'    				=> 'styling_transform_foot',
						'type'  				=> 'select',
						'title' 				=> __( "Table Foot: Text Transform", "ts_visual_composer_extend" ),
						'options'				=> array_flip(isset($TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms) ? $TS_ADVANCED_TABLESWP->TS_TablesWP_Styling_TextTransforms : $select_fallback),
						'default'  				=> 'none',
						'chosen'				=> true,
						'dependency'   			=> array('id|styling_customize', 'any|==', $select_tables . '|true'),
						'help'  				=> __( "Select the text transform property for the table footer section.", "ts_visual_composer_extend" ),
					),
					// Conditional Output
					array(
						'type'					=> 'heading',
						'content'				=> __( "Output Conditions", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'limitvisibility',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Conditions: Control Table Rendering", "ts_visual_composer_extend" ),
						'default' 				=> 'false',							
						'help' 					=> __( "Switch the toggle if you want to prevent the table from rendering if certain conditions are met.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'    				=> 'processing',
						'type'  				=> 'select',
						'title' 				=> __( "Conditions: Processing", "ts_visual_composer_extend" ),
						'options'				=> array(
							"server" 						=> __("WordPress Time", "ts_visual_composer_extend"),
							"client" 						=> __("Client Browser (JS/CSS)", "ts_visual_composer_extend"),
							//"shortcode" 					=> __("Callback: Custom Shortcode", "ts_visual_composer_extend"),
							//"function" 					=> __("Callback: Custom Function", "ts_visual_composer_extend"),
						),
						'default'  				=> 'server',				
						'help'  				=> __( "Select how the date and/or time dependency for the table should be processed and/or determined.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility', 'any|==', $select_tables . '|true'),
					),						
					array(
						'id'    				=> 'dependency',
						'type'  				=> 'select',
						'title' 				=> __( "Conditions: Times / Dates", "ts_visual_composer_extend" ),
						'options'				=> array(
							"always" 						=> __("No Time/Date Dependency", "ts_visual_composer_extend"),
							"datetime" 						=> __("Date Range with Time", "ts_visual_composer_extend"),
							"dateonly" 						=> __("Date Range Only", "ts_visual_composer_extend"),
							"timeonly" 						=> __("Time Range Only", "ts_visual_composer_extend"),
							"weekdays" 						=> __("Weekday Specific", "ts_visual_composer_extend"),
						),
						'default'  				=> 'always',				
						'help'  				=> __( "Select how the dependency for the table should be defined.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility', 'any|==', $select_tables . '|true'),
					),
					array(
						'type'    				=> 'submessage',
						'style'   				=> 'warning',
						'content' 				=> __( "Learn more:", "ts_visual_composer_extend" ) . ' <a href="http://www.timeanddate.com/time/map/" target="_blank">' . __( 'Time Zones', "ts_visual_composer_extend" ) . '</a><br/>' . __( "The WordPress timezone offset, used as default value for this setting, has been identified as the following:", "ts_visual_composer_extend" ) . ' ' . TS_TablesWP_RetrieveServerTimezone(),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|any', $select_tables . '|true|datetime,dateonly,timeonly,weekdays'),
					),
					array(
						'id'    				=> 'timezone',
						'type'  				=> 'select',
						'title' 				=> __( "Conditions: Timezone", "ts_visual_composer_extend" ),
						'options'				=> array(
							"WP"							=> __( "WordPress Timezone", "ts_visual_composer_extend" ),
							"-12" 							=> 'GMT -12:00',
							"-11" 							=> 'GMT -11:00',
							"-10" 							=> 'GMT -10:00',
							"-9" 							=> 'GMT -09:00',
							"-8" 							=> 'GMT -08:00',
							"-7" 							=> 'GMT -07:00',
							"-6" 							=> 'GMT -06:00',
							"-5" 							=> 'GMT -05:00',
							"-4" 							=> 'GMT -04:00',
							"-3" 							=> 'GMT -03:00',
							"-2" 							=> 'GMT -02:00',
							"-1" 							=> 'GMT -01:00',
							"0" 							=> '00:00',
							"1" 							=> 'GMT +01:00',
							"2" 							=> 'GMT +02:00',
							"3" 							=> 'GMT +03:00',
							"3.5" 							=> 'GMT +03:30',
							"4" 							=> 'GMT +04:00',
							"4.5" 							=> 'GMT +04:30',
							"5" 							=> 'GMT +05:00',
							"5.5" 							=> 'GMT +05:30',
							"5.75" 							=> 'GMT +05:45',
							"6" 							=> 'GMT +06:00',
							"6.5" 							=> 'GMT +06:30',
							"7" 							=> 'GMT +07:00',
							"8" 							=> 'GMT +08:00',
							"9" 							=> 'GMT +09:00',
							"9.5" 							=> 'GMT +09:30',
							"10" 							=> 'GMT +10:00',
							"11" 							=> 'GMT +11:00',
							"12" 							=> 'GMT +12:00',
							"13" 							=> 'GMT +13:00',
						),
						'default'  				=> 'WP',
						'help'  				=> __( "Please define the timezone offset the date and/or time dependent content should be based on.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|any', $select_tables . '|true|datetime,dateonly,timeonly,weekdays'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Date + Time Range", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|datetime'),
					),
					array(
						'id'      				=> 'datetime_range',
						'type'    				=> 'datetimepicker',
						'title'    				=> __( "Date / Time Range", "ts_visual_composer_extend" ),
						"range" 				=> "true",
						"period" 				=> "datetime",
						"spacing"				=> 0,
						'default' 				=> date("m/d/Y") . " " . $current_time . "|", // date("m/d/Y", time() + 86400) . " 06:00 AM",
						'help' 					=> __( "Select the date and time range during which the content should be shown.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|datetime'),
					),
					array(
						"type"					=> "subheading",
						"content"				=> __( "Date Range Only", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|dateonly'),
					),
					array(
						'id'      				=> 'dateonly_range',
						'type'    				=> 'datetimepicker',
						'title'    				=> __( "Date Range Only", "ts_visual_composer_extend" ),
						"range" 				=> "true",
						"period" 				=> "date",
						"spacing"				=> 0,
						'default' 				=> date("m/d/Y") . "|", // date("m/d/Y", time() + 86400),
						'help' 					=> __( "Select the date range during which the content should be shown.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|dateonly'),
					),
					// Daily Time Range
					array(
						"type"					=> "subheading",
						"content"				=> __( "Daily Time Range", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|timeonly'),
					),
					array(
						'id'      				=> 'timeonly_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for each day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|timeonly'),
					),	
					array(
						'id'      				=> 'timeonly_weekend',
						'type'    				=> 'buttonswitch',
						'title'    				=> __( "Use Time Range on Weekends", "ts_visual_composer_extend" ),
						'default' 				=> 'true',							
						'help' 					=> __( "Switch the toggle if you want to use the time range above for weekends as well.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|timeonly'),
					),			
					array(
						"type"					=> "subheading",
						"content"				=> __( "Weekdays Specific Range", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),
					array(
						'id'    				=> 'mondays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Mondays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'mondays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Mondays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|mondays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'tuesdays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Tuesdays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'tuesdays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Tuesdays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|tuesdays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'wednesdays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Wednesdays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'wednesdays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Wednesdays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|wednesdays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'thursdays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Thursdays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'thursdays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Thursdays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|thursdays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'fridays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Fridays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'fridays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Fridays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|fridays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'saturdays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Saturdays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'saturdays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Saturdays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|saturdays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					array(
						'id'    				=> 'sundays_scope',
						'type'  				=> 'select',
						'title' 				=> __( "Sundays: Visibility Scope", "ts_visual_composer_extend" ),
						'options'				=> array(
							"full"						=> __("Show Content All Day", "ts_visual_composer_extend"),
							"period"					=> __("Show Content For A Period", "ts_visual_composer_extend"),
							"none"						=> __("Do Not Show Content", "ts_visual_composer_extend"),
						),
						'default'  				=> 'full',				
						'help'  				=> __( "Define if and when the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'chosen'				=> true,
						'dependency'   			=> array('id|limitvisibility|dependency', 'any|==|==', $select_tables . '|true|weekdays'),
					),	
					array(
						'id'      				=> 'sundays_period',
						'type'    				=> 'nouislider',
						'title'    				=> __( "Sundays: Time Range", "ts_visual_composer_extend" ),
						'default' 				=> "96,192",
						"min"                   => "1",			// 5 Minutes
						"max"                   => "288",		// 12:00 AM
						"step"                  => "1",			// 5 Minutes
						"range"					=> "true",
						"start"					=> "96",		// 8:00 AM
						"end"					=> "192",		// 4:00 PM
						'help' 					=> __( "Define the time range during which the content should be shown for this day of the week.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility|dependency|sundays_scope', 'any|==|==|==', $select_tables . '|true|weekdays|period'),
					),
					// Conditional WordPress Settings
					array(
						"type"					=> "subheading",
						"content"				=> __( "Other Conditions", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility', 'any|==', $select_tables . '|true'),
					),
					array(
						"id"        			=> "conditionals",
						'type'					=> 'conditionalview',
						'generator'				=> 'ts-tablenator-shortcode',
						'title'					=> __( "Conditions: WordPress Other", "ts_visual_composer_extend" ),
						'help'    				=> __( "Define additional conditions for the table output, based on WordPress parameters.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id|limitvisibility', 'any|==', $select_tables . '|true'),
					),					
					// Other Settings
					array(
						'id'      				=> 'margin_top',
						'type'					=> 'heading',
						'content'				=> __( "Other Settings", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'margin_top',
						'type'    				=> 'slider',
						'title'   				=> __( "Margin: Top", "ts_visual_composer_extend" ),
						'default' 				=> '0',						  
						'help'    				=> __( "Select the top margin for the element.", "ts_visual_composer_extend" ),
						'min' 					=> '-50',
						'max'					=> '200',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id'      				=> 'margin_bottom',
						'type'    				=> 'slider',
						'title'   				=> __( "Margin: Bottom", "ts_visual_composer_extend" ),
						'default' 				=> '0',						  
						'help'    				=> __( "Select the bottom margin for the element.", "ts_visual_composer_extend" ),
						'min' 					=> '-50',
						'max'					=> '200',
						'step'					=> '1',
						'unit'					=> 'px',
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'el_id',
						'type' 					=> 'text',
						'title' 				=> __( "Define ID Name", "ts_visual_composer_extend" ),
						'help' 					=> __( "Enter an unique ID for the element.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
					array(
						'id' 					=> 'el_class',
						'type' 					=> 'tageditor',
						'title' 				=> __( "Extra Class Names", "ts_visual_composer_extend" ),
						'help' 					=> __( "Enter additional class names for the element.", "ts_visual_composer_extend" ),
						'dependency'   			=> array('id', 'any', $select_tables),
					),
                )
            ));
		}
	}
	
	if (is_admin()) {
		//add_action('plugins_loaded',			'TS_TablesWP_Generator_Fields',                   999999999);
		add_action('csf_loaded',				'TS_TablesWP_Generator_Fields',                   999999999);
	}
?>